== Change Log

=== 5.4.2-fuse-03-00
* [MB-874|https://fusesource.com/issues/browse/MB-874]: enhance the diagnostic logging when using the LDAPLoginModule ([AMQ-3323|https://issues.apache.org/jira/browse/AMQ-3323], [AMQ-3308|https://issues.apache.org/jira/browse/AMQ-3308])
* [MB-859|https://fusesource.com/issues/browse/MB-859]: Add support for wildcards for LDAP authorization map ([AMQ-3400|https://issues.apache.org/jira/browse/AMQ-3400], [AMQ-3341|https://issues.apache.org/jira/browse/AMQ-3341])

=== 5.4.2-fuse-02-00
* [MB-819|http://fusesource.com/issues/browse/MB-819] - Virtual destinations and wildcards ([AMQ-3197|https://issues.apache.org/jira/browse/AMQ-3197])
* [MB-829|http://fusesource.com/issues/browse/MB-829] - Consumers won't get msgs after JMX operation removeMatchingMessages() was called on a queue ([AMQ-3193|https://issues.apache.org/jira/browse/AMQ-3193])
* [MB-830|http://fusesource.com/issues/browse/MB-830] - Connecting to broker using discovery protocol fails ([AMQ-2981|https://issues.apache.org/jira/browse/AMQ-2981])
* [MB-831|http://fusesource.com/issues/browse/MB-831] - > Wildcard does not seem to match for all trailing elements ([AMQ-3204|https://issues.apache.org/jira/browse/AMQ-3204])
* [MB-812|http://fusesource.com/issues/browse/MB-812] - Can only have one duplex networkConnection per transportConnection ([AMQ-3129|https://issues.apache.org/jira/browse/AMQ-3129])
* [MB-818|http://fusesource.com/issues/browse/MB-818] - 5.4 broker always sends out peer URIs which 5.3 clients always add to failover list ([AMQ-3178|https://issues.apache.org/jira/browse/AMQ-3178])
* [MB-722|http://fusesource.com/issues/browse/MB-722] - Cannot browse queues with bytes messages via JMX ([AMQ-3180|https://issues.apache.org/jira/browse/AMQ-3180])
* [AMQ-3120|https://issues.apache.org/jira/browse/AMQ-3120] - KahaDB error: "Could not locate data file"
* [MB-757|http://fusesource.com/issues/browse/MB-757] (Update) - KahaDB doesn't clean up old log files ([AMQ-2736|https://issues.apache.org/activemq/browse/AMQ-2736])
* [MB-824|http://fusesource.com/issues/browse/MB-824] - When two loging modules configured, one succeeds, one fails but both are adding their principals ([AMQ-3182|https://issues.apache.org/jira/browse/AMQ-3182],[AMQ-3183|https://issues.apache.org/jira/browse/AMQ-3183])
* [AMQ-3167|https://issues.apache.org/jira/browse/AMQ-3167] - possible skipped Queue messages in memory limited configuration with fast consumers resolve off by one error in messageOrderIndex setBatch
* [MB-797|http://fusesource.com/issues/browse/MB-797] - Recovering durable subs with priority and JDBC store - total message table scan is too slow ([AMQ-3188|https://issues.apache.org/jira/browse/AMQ-3188],[AMQ-3196|https://issues.apache.org/jira/browse/AMQ-3196])
* [MB-755|http://fusesource.com/issues/browse/MB-755] (Update) - Missing messages in durable subscription with selector and KahaDB ([AMQ-3190|https://issues.apache.org/activemq/browse/AMQ-3190])
* [MB-822:http://fusesource.com/issues/browse/MB-822] - Please clean up log messages when connecting to the broker using STOMP client with a wrong name/password pair
* [MB-572|http://fusesource.com/issues/browse/MB-752] - Add setTrustStore() and setKeyStore() methods to ActiveMQSslConnectionFactory class ([AMQ-3192|https://issues.apache.org/jira/browse/AMQ-3192])
* [MB-804|http://fusesource.com/issues/browse/MB-804] - NetworkConnection initialization should be backed by an executor ([AMQ-3195|https://issues.apache.org/jira/browse/AMQ-3195])
* [MB-833|http://fusesource.com/issues/browse/MB-833] - Allow JAAS GuestLoginModule to fail if users specify a password ([AMQ-3198|ttps://issues.apache.org/jira/browse/AMQ-3198])
* [MB-834|http://fusesource.com/issues/browse/MB-834] - using durable subs messages stay in KahaDB indefinitely if broker is restarted ([AMQ-3206|https://issues.apache.org/jira/browse/AMQ-3206])

=== 5.4.2-fuse-01-00

* [MB-808|http://fusesource.com/issues/browse/MB-808] - Upgrade to Camel 2.6.0-fuse-00-00
* [MB-803|http://fusesource.com/issues/browse/MB-803] - originalDestination of messages in DLQ queue is not sent out as a frame header in STOMP ([AMQ-3146|https://issues.apache.org/jira/browse/AMQ-3146])
* [MB-802|http://fusesource.com/issues/browse/MB-802] - Change StoreLimit value via JMX Console is not take into account when throwing exception on store full condition.
* [MB-795|http://fusesource.com/issues/browse/MB-795] - Change StoreLimit value via JMX Console is not take in count. ([AMQ-3143|https://issues.apache.org/jira/browse/AMQ-3143])
* [MB-800|http://fusesource.com/issues/browse/MB-800] - concurrentStoreAndDispatchQueues when cache disabled can lead to skipped message dispatch, leaving message pending for some time ([AMQ-3149|https://issues.apache.org/jira/browse/AMQ-3149],[AMQ-3145|https://issues.apache.org/jira/browse/AMQ-3145])
* [MB-791|http://fusesource.com/issues/browse/MB-791] - Producer Flow Control Does Not Seem to Work with Topics ([AMQ-2683|https://issues.apache.org/jira/browse/AMQ-2683])
* [MB-760|http://fusesource.com/issues/browse/MB-760] - Provide a way to query a networkconnector for status via JMX ([AMQ-3107|https://issues.apache.org/jira/browse/AMQ-3107])
* [MB-753|http://fusesource.com/issues/browse/MB-753] - Proxy connector with failover does not work for durable subscribers ([AMQ-3119|https://issues.apache.org/jira/browse/AMQ-3119])
* [MB-792|http://fusesource.com/issues/browse/MB-792] - Persistent file based database, Kahadb, is corrupt when an out of disk space situation occurs (AMQ-3122|https://issues.apache.org/jira/browse/AMQ-3122])
* [MB-784|http://fusesource.com/issues/browse/MB-784] - java.lang.IndexOutOfBoundsException in FailoverTransport.updateURIs
* [AMQ-3115|https://issues.apache.org/jira/browse/AMQ-3115] - reportInterval property ignored by DiscardingDLQBrokerPlugin
* [AMQ-3125|https://issues.apache.org/jira/browse/AMQ-3125] - updateClusterFilter/ClientsOnRemove broken when running JMX broker
* [AMQ-3124|https://issues.apache.org/jira/browse/AMQ-3124] - Failover transport client gets corrupted connectedBrokers data
* [AMQ-3077|https://issues.apache.org/jira/browse/AMQ-3077] - ArraysIndexOutOfBoundsException : -32768 in "BrokerService[xxx] Task" thread
* [AMQ-3134|https://issues.apache.org/jira/browse/AMQ-3134] - Add support of MS SQL JDBC driver (version 3.0)
* [AMQ-3148|https://issues.apache.org/jira/browse/AMQ-3148] - LoggingBrokerPlugin addConnection(..) log output is meaningless
* [AMQ-3162|https://issues.apache.org/jira/browse/AMQ-3162] - ActiveMQ checkpoint worker makes unnecessary repeated calls to Journal.getFileMap(), leading to excessive memory usage
* [AMQ-3160|https://issues.apache.org/jira/browse/AMQ-3160] - ConcurrentModificationException in ActiveMQ Journal Checkpoint Worker
* [AMQ-3161|https://issues.apache.org/jira/browse/AMQ-3161] - Race condition in ActiveMQ Journal Checkpoint worker thread cleanup leads to multiple running instances
* [AMQ-3159|https://issues.apache.org/jira/browse/AMQ-3159] - Log file offset in addition to file location in checkpointUpdate()
* [AMQ-3038|https://issues.apache.org/jira/browse/AMQ-3038] - fix unit test regression, a temp dest may have a null conneciton if it was added from an advisory
=== 5.4.2-fuse-00-00

* [MB-781|http://fusesource.com/issues/browse/MB-781] - ActiveMQ's <managementContext> does not allow configuration of SSL or JAAS ([AMQ-3044|https://issues.apache.org/jira/browse/AMQ-3044])
* [MB-778|http://fusesource.com/issues/browse/MB-778] - Deleting a Queue from the console results in lost messages. ([AMQ-3092|https://issues.apache.org/jira/browse/AMQ-3092])
* [MB-777|http://fusesource.com/issues/browse/MB-777] - Memory leak in SimpleAuthenticationBroker ([AMQ-3052|https://issues.apache.org/activemq/browse/AMQ-3052])
* [MB-776|http://fusesource.com/issues/browse/MB-776] - initialReconnectDelay on failover transport is not being honoured ([https://issues.apache.org/activemq/browse/AMQ-3049|https://issues.apache.org/activemq/browse/AMQ-3049])
* [MB-772|http://fusesource.com/issues/browse/MB-772] - WARN Service - Failed to remove connection ConnectionInfo (java.util.ConcurrentModificationException)
* [MB-767|http://fusesource.com/issues/browse/MB-767] - activemq stop script always returns 1 ([https://issues.apache.org/activemq/browse/AMQ-3050|https://issues.apache.org/activemq/browse/AMQ-3050])
* [AMQ-3056|https://issues.apache.org/activemq/browse/AMQ-3056] - Exception when Redelivery ack is processed by topic subscription
* [AMQ-3067|https://issues.apache.org/activemq/browse/AMQ-3067] - ActiveMQBlobMessage.copy(..) does not copy the name attribute
* [AMQ-3062|https://issues.apache.org/activemq/browse/AMQ-3062] - "Deflater has been closed" exception when jms.useCompression=true and using ActiveMQBytesMessage
* [AMQ-3071|https://issues.apache.org/activemq/browse/AMQ-3071] - ConcurrentModificationException thrown in PriorityNetworkDispatchPolicy
* [AMQ-3015|https://issues.apache.org/activemq/browse/AMQ-3015] - Javascript client does not establish session properly.
* [AMQ-3068|https://issues.apache.org/activemq/browse/AMQ-3068] - Error creating tables on Oracle jdbc store
* [AMQ-3081|https://issues.apache.org/activemq/browse/AMQ-3081] - Durable subscriptions are not removed from mbean
* [AMQ-3033|https://issues.apache.org/activemq/browse/AMQ-3033] - BrokerService leaks threads when scheduler or jmx are enabled
* [AMQ-2492|https://issues.apache.org/activemq/browse/AMQ-2492] - Microsoft SQL Server JDBC Driver 2.0 not recognized
* [AMQ-3075|https://issues.apache.org/activemq/browse/AMQ-3075] - Auto-create database fails with PostgreSQL (Error in SQL: 'drop primary key')
* [AMQ-3085|https://issues.apache.org/activemq/browse/AMQ-3085] - IndexOutOfBoundsException on FailoverTransport.updateURIs after: already known: java.net.UnknownHostException
* [AMQ-3095|https://issues.apache.org/activemq/browse/AMQ-3095] - Broker policyEntry DurableTopicPrefetch is ignored by default because of connection.optimizedMessageDispatch
* [AMQ-3076|https://issues.apache.org/activemq/browse/AMQ-3076] - spurious KahaDB warnings
* [AMQ-3084|https://issues.apache.org/activemq/browse/AMQ-3084] - Typo "DispachedCounter" in response when running activemq-admin

=== 5.4.1-fuse-01-00

* [MB-710|http://fusesource.com/issues/browse/MB-710] - Message store is not cleaned when durable topic subscribers are refusing messages ([AMQ-2584|https://issues.apache.org/activemq/browse/AMQ-2584])
* [MB-726|http://fusesource.com/issues/browse/MB-726] - ActiveMQConnection.close logs stack trace in INFO level ([AMQ-2902|https://issues.apache.org/activemq/browse/AMQ-2902])
* [MB-730|http://fusesource.com/issues/browse/MB-730] - Null messages occurring when using VM transport, topics and multiple consumers
* [MB-734|http://fusesource.com/issues/browse/MB-734] - Inactivity monitor for http/https transport reverts back to default 30 second readCheckTime
* [MB-736|http://fusesource.com/issues/browse/MB-736] - XA Transaction not cleaned up in broker on ungraceful exit of XA producer. ([AMQ-2950|https://issues.apache.org/activemq/browse/AMQ-2950])
* [MB-745|http://fusesource.com/issues/browse/MB-745] - java.io.EOFException: Chunk stream does not exist at page on broker start ([AMQ-2935|https://issues.apache.org/activemq/browse/AMQ-2935])
* [MB-747|http://fusesource.com/issues/browse/MB-747] - Seeing inflight messages that are not consumed when jmsPriority is enabled and have intermittent durable consumer ([AMQ-2980|https://issues.apache.org/activemq/browse/AMQ-2980])
* [MB-751|http://fusesource.com/issues/browse/MB-751] - bin/activemq depends on /bin/bash, and that is not present by default on AIX 5.3 systems ([AMQ-2453|https://issues.apache.org/activemq/browse/AMQ-2453])
* [MB-754|http://fusesource.com/issues/browse/MB-754] - StorePercentUsage value never decreases ([AMQ-2986|https://issues.apache.org/activemq/browse/AMQ-2986])
* [MB-755|http://fusesource.com/issues/browse/MB-755] - Missing messages in durable subscription with selector and KahaDB ([AMQ-2985|https://issues.apache.org/activemq/browse/AMQ-2985])
* [MB-757|http://fusesource.com/issues/browse/MB-757] - KahaDB doesn't clean up old log files ([AMQ-2736|https://issues.apache.org/activemq/browse/AMQ-2736])
* [MB-758|http://fusesource.com/issues/browse/MB-758] - Virtual topic interceptor process advisory messages ([AMQ-2993|https://issues.apache.org/activemq/browse/AMQ-2993])
* [MB-759|http://fusesource.com/issues/browse/MB-759] - Message getting stuck on queue, leading to KahaDB log files not being deleted and disk running out of space ([AMQ-2955|https://issues.apache.org/activemq/browse/AMQ-2955])
* [MB-762|http://fusesource.com/issues/browse/MB-762] - Dispatch counter incrementing with queue browser poll but no consumers/producers attached to broker. ([AMQ-3020|https://issues.apache.org/activemq/browse/AMQ-3020])
* [MB-763|http://fusesource.com/issues/browse/MB-763] - Problem of removing durableSubscribers from BrokerView ([AMQ-3013|https://issues.apache.org/activemq/browse/AMQ-3013])
* [MB-766|http://fusesource.com/issues/browse/MB-766] - Failover transport blocking when uri sets watchTopicAdvisories=false
* [MB-771|http://fusesource.com/issues/browse/MB-771] - ./bin/activemq script ignores ACTIVEMQ_SSL_OPTS from environment ([AMQ-3035|https://issues.apache.org/activemq/browse/AMQ-3035])

* [AMQ-3021|https://issues.apache.org/activemq/browse/AMQ-3021] - HttpTunnelServlet leaks BlockingQueueTransport objects, causing eventual OOM on heap space
* [AMQ-2925|https://issues.apache.org/activemq/browse/AMQ-2925] - PooledConnection.getConnection() should be public
* [AMQ-2927|https://issues.apache.org/activemq/browse/AMQ-2927] - Implement custom brokerId assignment strategy
* [AMQ-2942|https://issues.apache.org/activemq/browse/AMQ-2942] - Can't configure an inactivity monitor for https transport
* [AMQ-2938|https://issues.apache.org/activemq/browse/AMQ-2938] - ActiveMQ Console requires Jasypt bundle which is not part of the ActiveMQ features
* [AMQ-2885|https://issues.apache.org/activemq/browse/AMQ-2885] - Upgrade aries to 0.1-r964701
* [AMQ-2941|https://issues.apache.org/activemq/browse/AMQ-2941] - Add a non-JMX way to browse and delete scheduled/delayed messages
* [AMQ-2940|https://issues.apache.org/activemq/browse/AMQ-2940] - Add a way to select and delete scheduled/delayed messages with a message selector
* [AMQ-2966|https://issues.apache.org/activemq/browse/AMQ-2966] - Null messages occurring when using VM transport, topics and multiple consumers
* [AMQ-2967|https://issues.apache.org/activemq/browse/AMQ-2967] - Have Schedular support disabled by default
* [AMQ-2959|https://issues.apache.org/activemq/browse/AMQ-2959] - Scheduler not honoring activemq.store.dir property
* [AMQ-2973|https://issues.apache.org/activemq/browse/AMQ-2973] - Removing composite subscription clears all dispatched messages	  
* [AMQ-2948|https://issues.apache.org/activemq/browse/AMQ-2948] - Support ajax clients in multiple windows/tabs in a single browser	  
* [AMQ-2103|https://issues.apache.org/activemq/browse/AMQ-2103] - Memory leak when marshaling ActiveMQTextMessage to persistent store  
* [AMQ-2975|https://issues.apache.org/activemq/browse/AMQ-2975] - New shell scripts doesn't work well with multiple broker instances	  
* [AMQ-2972|https://issues.apache.org/activemq/browse/AMQ-2972] - STOMP over Websockets do not work in Chrome
* [AMQ-2945|https://issues.apache.org/activemq/browse/AMQ-2945] - KahaDB corrupted when too many messages accumulate: EOFException	  
* [AMQ-2989|https://issues.apache.org/activemq/browse/AMQ-2989] - Upgrade xmlpull with xpp3
* [AMQ-2990|https://issues.apache.org/activemq/browse/AMQ-2990] - Allow to specify the chunk size when using JMS Stream (ActiveMQOutputStream)	  
* [AMQ-2970|https://issues.apache.org/activemq/browse/AMQ-2970] - Fire advisory events when destinations are created/delete via JMX
* [AMQ-2988|https://issues.apache.org/activemq/browse/AMQ-2988] - Allow to retrieve the JMSProperties when using JMS Stream (ActiveMQInputStream)
* [AMQ-2999|https://issues.apache.org/activemq/browse/AMQ-2999] - peer transport factory mapping localhost incorrectly to loopback
* [AMQ-2982|https://issues.apache.org/activemq/browse/AMQ-2982] - Sticky KahaDB log files due to local transaction rollback
* [AMQ-2983|https://issues.apache.org/activemq/browse/AMQ-2983] - Sticky KahaDB log files due to concurrent consumer with local transaction
* [AMQ-3007|https://issues.apache.org/activemq/browse/AMQ-3007] - Kahadb LockFile.lock() leaks file descriptors if tryLock() returns an IOException
* [AMQ-2952|https://issues.apache.org/activemq/browse/AMQ-2952] - Message groups with small prefetch
* [AMQ-2551|https://issues.apache.org/activemq/browse/AMQ-2551] - Locking issue with MySQL InnoDB
* [AMQ-2764|https://issues.apache.org/activemq/browse/AMQ-2764] - For "duplex" network connection, after restart one ActiveMQ, message is missing.
* [AMQ-3025|https://issues.apache.org/activemq/browse/AMQ-3025] - ActiveMQ child instances create their PID file in the parent's data directory and refer to the parent's configuration files when started
* [AMQ-2939|https://issues.apache.org/activemq/browse/AMQ-2939] - Disable Spring 3 schema validation
* [AMQ-3029|https://issues.apache.org/activemq/browse/AMQ-3029] - Exception when try to browse ActiveMQBlobMessage via JMX
* [AMQ-2930|https://issues.apache.org/activemq/browse/AMQ-2930] - Does ActiveMQ run on Windows Vista and/or Windows 7?
* [AMQ-2932|https://issues.apache.org/activemq/browse/AMQ-2932] - A little optimization to IdGenerator and a potential issue with the counter
* [AMQ-2997|https://issues.apache.org/activemq/browse/AMQ-2997] - Default log4j.properties has Camel set at ERROR level. Please lower this to WARN or maybe even better at INFO
* [AMQ-3005|https://issues.apache.org/activemq/browse/AMQ-3005] - The spring.schemas file contains an invalid mapping

===  5.4.1-fuse-00-00

* All changes included in Apache ActiveMQ 5.4.1 release
* [https://issues.apache.org/activemq/browse/AMQ-2925]: PooledConnection.getConnection() should be public
* [https://issues.apache.org/activemq/browse/AMQ-2927]: Implement custom brokerId assignment strategy
* [https://issues.apache.org/activemq/browse/AMQ-2942]: Can't configure an inactivity monitor for https transport
* [https://issues.apache.org/activemq/browse/AMQ-2938]: ActiveMQ Console requires Jasypt bundle which is not part of the ActiveMQ features
* [https://issues.apache.org/activemq/browse/AMQ-2885]: Upgrade aries to 0.1-r964701
* [https://issues.apache.org/activemq/browse/AMQ-2932]: A little optimization to IdGenerator and a potential issue with the counter


